--DERIVATOR--------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.numeric_std.all;
use ieee.std_logic_unsigned.all;
use work.global_package.all;

entity derivator is
   Port ( error : in integer;
			 clk : in std_logic;
			 PID_state : in PID_state_type;
			 derivator_out : out integer := 0;
			 D_done : inout std_logic := '0'
   );
end derivator;

architecture basic of derivator is
begin
	derivator_proc : process (clk)
	constant Kd : integer := 1;
	variable error_t1 : integer := 0;
	begin
	   if (clk='0' and clk'event) then
			if(PID_state = calc_PID and D_done <= '0') then
				derivator_out <= Kd * (error - error_t1);
				error_t1 := error;
				D_done <= '1';
			elsif(PID_state = calc_sum) then D_done <= '0'; 
			end if;
		end if;
	end process derivator_proc;
end architecture basic;