--------------------------------------------------------------------------------
-- Company: Siemens Oil & Gas
-- Engineer: Erik Nss
--
-- Create Date:   01:44:20 02/01/2009
-- Design Name:   PID Regulator
-- Module Name:   C:/Xilinx/PID_Reg/PID_Regulator_TB.vhd
-- Project Name:  PID_Reg
-- Target Device:  
-- Tool versions:  
-- Description: Masters assignment,  under supervision by Karstein Kristiansen (Siemens) &
-- 				 Sverre Hendseth (NTNU - Teknisk Kybernetikk)
-- 
-- VHDL Test Bench Created by ISE for module: PID_Regulator
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use ieee.std_logic_unsigned.all;
 
ENTITY PID_Regulator_TB IS
END PID_Regulator_TB;
 
ARCHITECTURE behavior OF PID_Regulator_TB IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT PID_Regulator
    PORT(
         clk : IN  std_logic;
			ROT_CENTER : in std_logic;
			SPI_MISO : in std_logic := '0';
			SPI_MOSI : out std_logic;
			SPI_SCK : inout std_logic;
			AMP_CS : out std_logic;
			DAC_CS : out std_logic;
			UART_RXD : in std_logic;
			UART_TXD : out std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal clk : std_logic := '0';
	signal ROT_CENTER : std_logic := '0';
	signal SPI_MISO : std_logic;
	signal SPI_SCK : std_logic;
	signal UART_RXD : std_logic;

 	--Outputs
	signal SPI_MOSI : std_logic;
	signal SPI_SSEL : std_logic;
	signal AMP_CS : std_logic;
	signal DAC_CS : std_logic;
	signal UART_TXD : std_logic;

   -- Clock period definitions
   constant clk_period : time := 20ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: PID_Regulator PORT MAP (
          clk => clk,
			 ROT_CENTER => ROT_CENTER,
			 SPI_MISO => SPI_MISO,
			 SPI_MOSI => SPI_MOSI,
			 SPI_SCK => SPI_SCK,
			 AMP_CS => AMP_CS,
			 DAC_CS => DAC_CS,
			 UART_RXD  => UART_RXD,
			 UART_TXD  => UART_TXD
        );

   -- Clock process definitions
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
	
	-- Test process
	test : process (clk)
	begin
		if(clk'event and clk='1') then
			SPI_MISO <= '1';
			UART_RXD  <= UART_TXD;
		end if;
	end process;

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100ms.
      wait for 100ms;	

      wait for clk_period*10;

      -- insert stimulus here 

      wait;
   end process;

END;
