--PID STATEMACHINE CONTROLLER--------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.numeric_std.all;
use ieee.std_logic_unsigned.all;
use work.global_package.all;

entity SYS_SM is
   Port ( clk : in std_logic;
			 SYS_state : inout SYS_state_type := idle;
			 SPI_done, MPC_done : in std_logic
   );
end SYS_SM;

architecture basic of SYS_SM is
begin
	SYS_SM_proc : process (clk) is
	variable counter : integer range 0 to clk_speed := 0;
	begin
	   if (clk='0' and clk'event) then
			counter := counter + 1;
			if(counter >= clk_pr_sample and SYS_state = idle) then
				SYS_state <= calc_MPC;
				counter := 0;
			end if;
			if(SYS_state=calc_MPC and MPC_done = '1') then
				SYS_state <= run_SPI;
			elsif(SYS_state=run_SPI and SPI_done = '1') then
				SYS_state <= idle;
			end if;
		end if;
	end process SYS_SM_proc;
end architecture basic;