--UART--------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.numeric_std.all;
use ieee.std_logic_unsigned.all;
use work.global_package.all;

entity automan is
   Port ( clk 	: in std_logic;
			 PID_u1 : in std_logic_vector(11 downto 0);
			 Ref : in std_logic_vector(7 downto 0);
			 MPC_u1 : in std_logic_vector(11 downto 0);
			 mode : in std_logic_vector(1 downto 0); 
			 Out_Value : out std_logic_vector(11 downto 0) := "000000000000"
   );
end automan;

architecture basic of automan is
begin
	automan_proc : process (clk)
	begin
	   if (clk='0' and clk'event) then
			case mode is
				when "00" => Out_value <= Ref & "0000"; 	--Manual mode
				when "01" => Out_value <= PID_u1;	 		--PID mode
				when "10" => Out_value <= MPC_u1;	 		--MPC mode
				when others => Out_value <= Ref & "0000"; --Manual mode
			end case;
		end if;
	end process automan_proc;
end architecture basic;