--CHARACTER GENERATOR
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.numeric_std.all;
use ieee.std_logic_unsigned.all;
use work.global_package.all;

entity char_gen is
   Port ( VGA_CLK : in std_logic;
			 char : in std_logic_vector(7 downto 0);
			 vec_0: out std_logic_vector(7 downto 0);
			 vec_1: out std_logic_vector(7 downto 0);
			 vec_2: out std_logic_vector(7 downto 0);
			 vec_3: out std_logic_vector(7 downto 0);
			 vec_4: out std_logic_vector(7 downto 0);
			 vec_5: out std_logic_vector(7 downto 0);
			 vec_6: out std_logic_vector(7 downto 0);
			 vec_7: out std_logic_vector(7 downto 0)
   );
end char_gen;

architecture basic of char_gen is
begin
	char_gen_proc : process (VGA_CLK) is
	begin
	   if (VGA_CLK='0' and VGA_CLK'event) then
			case char is
			when "00100000" => vec_0 <= "00000000";	--Letter "space"
									 vec_1 <= "00000000";
									 vec_2 <= "00000000";
									 vec_3 <= "00000000";
									 vec_4 <= "00000000";
									 vec_5 <= "00000000";
									 vec_6 <= "00000000";
									 vec_7 <= "00000000";
			when "00101011" => vec_0 <= "00011000";	--Letter "+"
									 vec_1 <= "00011000";
									 vec_2 <= "00011000";
									 vec_3 <= "11111111";
									 vec_4 <= "11111111";
									 vec_5 <= "00011000";
									 vec_6 <= "00011000";
									 vec_7 <= "00011000";
			when "00101100" => vec_0 <= "00000000";	--Letter ","
									 vec_1 <= "00000000";
									 vec_2 <= "00000000";
									 vec_3 <= "00000000";
									 vec_4 <= "00000000";
									 vec_5 <= "00111000";
									 vec_6 <= "00111000";
									 vec_7 <= "00110000";
			when "00101110" => vec_0 <= "00000000";	--Letter "."
									 vec_1 <= "00000000";
									 vec_2 <= "00000000";
									 vec_3 <= "00000000";
									 vec_4 <= "00000000";
									 vec_5 <= "00111000";
									 vec_6 <= "00111000";
									 vec_7 <= "00000000";
			when "00101101" => vec_0 <= "00000000";	--Letter "-"
									 vec_1 <= "00000000";
									 vec_2 <= "00000000";
									 vec_3 <= "11111111";
									 vec_4 <= "11111111";
									 vec_5 <= "00000000";
									 vec_6 <= "00000000";
									 vec_7 <= "00000000";
			when "00101111" => vec_0 <= "00000000";	--Letter "/"
									 vec_1 <= "00000010";
									 vec_2 <= "00000110";
									 vec_3 <= "00001100";
									 vec_4 <= "00011000";
									 vec_5 <= "00110000";
									 vec_6 <= "01100000";
									 vec_7 <= "01000000";
			when "00110000" => vec_0 <= "01111100";	--Number "0"
									 vec_1 <= "11000110";
									 vec_2 <= "11100110";
									 vec_3 <= "11010110";
									 vec_4 <= "11001110";
									 vec_5 <= "11000110";
									 vec_6 <= "01111100";
									 vec_7 <= "00000000";
			when "00110001" => vec_0 <= "00011000";	--Number "1"
									 vec_1 <= "00111000";
									 vec_2 <= "00011000";
									 vec_3 <= "00011000";
									 vec_4 <= "00011000";
									 vec_5 <= "00011000";
									 vec_6 <= "00111100";
									 vec_7 <= "00000000";
			when "00110010" => vec_0 <= "01111100";	--Number "2"
									 vec_1 <= "11000110";
									 vec_2 <= "00000110";
									 vec_3 <= "00000110";
									 vec_4 <= "01111100";
									 vec_5 <= "11000000";
									 vec_6 <= "11111110";
									 vec_7 <= "00000000";
			when "00110011" => vec_0 <= "01111100";	--Number "3"
									 vec_1 <= "11000110";
									 vec_2 <= "00000110";
									 vec_3 <= "00011100";
									 vec_4 <= "00000110";
									 vec_5 <= "11000110";
									 vec_6 <= "01111100";
									 vec_7 <= "00000000";
			when "00110100" => vec_0 <= "00011100";	--Number "4"
									 vec_1 <= "00101100";
									 vec_2 <= "01001100";
									 vec_3 <= "10001100";
									 vec_4 <= "10001100";
									 vec_5 <= "11111110";
									 vec_6 <= "00001100";
									 vec_7 <= "00000000";
			when "00110101" => vec_0 <= "11111110";	--Number "5"
									 vec_1 <= "10000000";
									 vec_2 <= "11111100";
									 vec_3 <= "11000110";
									 vec_4 <= "00000110";
									 vec_5 <= "11000110";
									 vec_6 <= "01111100";
									 vec_7 <= "00000000";
			when "00110110" => vec_0 <= "01111100";	--Number "6"
									 vec_1 <= "11000110";
									 vec_2 <= "11000000";
									 vec_3 <= "11111100";
									 vec_4 <= "11000110";
									 vec_5 <= "11000110";
									 vec_6 <= "01111100";
									 vec_7 <= "00000000";
			when "00110111" => vec_0 <= "11111110";	--Number "7"
									 vec_1 <= "11000110";
									 vec_2 <= "00000110";
									 vec_3 <= "00001100";
									 vec_4 <= "00001100";
									 vec_5 <= "00011000";
									 vec_6 <= "00011000";
									 vec_7 <= "00000000";
			when "00111000" => vec_0 <= "01111100";	--Number "8"
									 vec_1 <= "11000110";
									 vec_2 <= "11000110";
									 vec_3 <= "01111100";
									 vec_4 <= "11000110";
									 vec_5 <= "11000110";
									 vec_6 <= "01111100";
									 vec_7 <= "00000000";
			when "00111001" => vec_0 <= "01111100";	--Number "9"
									 vec_1 <= "11000110";
									 vec_2 <= "11000110";
									 vec_3 <= "01111110";
									 vec_4 <= "00000110";
									 vec_5 <= "11000110";
									 vec_6 <= "01111100";
									 vec_7 <= "00000000";
			when "00111010" => vec_0 <= "00000000";	--Symbol ":"
									 vec_1 <= "00011000";
									 vec_2 <= "00011000";
									 vec_3 <= "00000000";
									 vec_4 <= "00000000";
									 vec_5 <= "00011000";
									 vec_6 <= "00011000";
									 vec_7 <= "00000000";
			when "00111101" => vec_0 <= "00000000";	--Symbol "="
									 vec_1 <= "00000000";
									 vec_2 <= "01111110";
									 vec_3 <= "00000000";
									 vec_4 <= "00000000";
									 vec_5 <= "01111110";
									 vec_6 <= "00000000";
									 vec_7 <= "00000000";
			when "01000001" => vec_0 <= "01111100";	--Letter "A"
									 vec_1 <= "11000110";
									 vec_2 <= "11000110";
									 vec_3 <= "11111110";
									 vec_4 <= "11000110";
									 vec_5 <= "11000110";
									 vec_6 <= "11000110";
									 vec_7 <= "00000000";
			when "01000010" => vec_0 <= "11111100";	--Letter "B"
									 vec_1 <= "11000110";
									 vec_2 <= "11000110";
									 vec_3 <= "11111100";
									 vec_4 <= "11000110";
									 vec_5 <= "11000110";
									 vec_6 <= "11111100";
									 vec_7 <= "00000000";
			when "01000011" => vec_0 <= "01111100";	--Letter "C"
									 vec_1 <= "11000110";
									 vec_2 <= "11000000";
									 vec_3 <= "11000000";
									 vec_4 <= "11000000";
									 vec_5 <= "11000110";
									 vec_6 <= "01111100";
									 vec_7 <= "00000000";
			when "01000100" => vec_0 <= "11111100";	--Letter "D"
									 vec_1 <= "11000110";
									 vec_2 <= "11000110";
									 vec_3 <= "11000110";
									 vec_4 <= "11000110";
									 vec_5 <= "11000110";
									 vec_6 <= "11111100";
									 vec_7 <= "00000000";
			when "01000101" => vec_0 <= "11111110";	--Letter "E"
									 vec_1 <= "11000000";
									 vec_2 <= "11000000";
									 vec_3 <= "11111000";
									 vec_4 <= "11000000";
									 vec_5 <= "11000000";
									 vec_6 <= "11111110";
									 vec_7 <= "00000000";
			when "01000110" => vec_0 <= "11111110";	--Letter "F"
									 vec_1 <= "11000000";
									 vec_2 <= "11000000";
									 vec_3 <= "11111000";
									 vec_4 <= "11000000";
									 vec_5 <= "11000000";
									 vec_6 <= "11000000";
									 vec_7 <= "00000000";
			when "01001001" => vec_0 <= "01111110";	--Letter "I"
									 vec_1 <= "00011000";
									 vec_2 <= "00011000";
									 vec_3 <= "00011000";
									 vec_4 <= "00011000";
									 vec_5 <= "00011000";
									 vec_6 <= "01111110";
									 vec_7 <= "00000000";
			when "01001011" => vec_0 <= "11000110";	--Letter "K"
									 vec_1 <= "11000110";
									 vec_2 <= "11001100";
									 vec_3 <= "11111000";
									 vec_4 <= "11001100";
									 vec_5 <= "11000110";
									 vec_6 <= "11000110";
									 vec_7 <= "00000000";
			when "01001101" => vec_0 <= "11000110";	--Letter "M"
									 vec_1 <= "11101110";
									 vec_2 <= "11111110";
									 vec_3 <= "11010110";
									 vec_4 <= "11000110";
									 vec_5 <= "11000110";
									 vec_6 <= "11000110";
									 vec_7 <= "00000000";
			when "01010000" => vec_0 <= "11111100";	--Letter "P"
									 vec_1 <= "11000110";
									 vec_2 <= "11000110";
									 vec_3 <= "11111100";
									 vec_4 <= "11000000";
									 vec_5 <= "11000000";
									 vec_6 <= "11000000";
									 vec_7 <= "00000000";
			when "01010010" => vec_0 <= "11111100";	--Letter "R"
									 vec_1 <= "11000110";
									 vec_2 <= "11000110";
									 vec_3 <= "11111100";
									 vec_4 <= "11000110";
									 vec_5 <= "11000110";
									 vec_6 <= "11000110";
									 vec_7 <= "00000000";
			when "01010100" => vec_0 <= "01111110";	--Letter "T"
									 vec_1 <= "00011000";
									 vec_2 <= "00011000";
									 vec_3 <= "00011000";
									 vec_4 <= "00011000";
									 vec_5 <= "00011000";
									 vec_6 <= "00011000";
									 vec_7 <= "00000000";
			when "01011000" => vec_0 <= "11000011";	--Letter "X"
									 vec_1 <= "01100110";
									 vec_2 <= "00111100";
									 vec_3 <= "00011000";
									 vec_4 <= "00111100";
									 vec_5 <= "01100110";
									 vec_6 <= "11000011";
									 vec_7 <= "00000000";
			when "01100001" => vec_0 <= "00000000";	--Letter "a"
									 vec_1 <= "01111100";
									 vec_2 <= "00000110";
									 vec_3 <= "01111110";
									 vec_4 <= "11000110";
									 vec_5 <= "11000110";
									 vec_6 <= "01111110";
									 vec_7 <= "00000000";
			when "01100010" => vec_0 <= "11000000";	--Letter "b"
									 vec_1 <= "11111100";
									 vec_2 <= "11000110";
									 vec_3 <= "11000110";
									 vec_4 <= "11000110";
									 vec_5 <= "11000110";
									 vec_6 <= "11111100";
									 vec_7 <= "00000000";
			when "01100011" => vec_0 <= "00000000";	--Letter "c"
									 vec_1 <= "01111000";
									 vec_2 <= "11000100";
									 vec_3 <= "11000000";
									 vec_4 <= "11000000";
									 vec_5 <= "11000100";
									 vec_6 <= "01111000";
									 vec_7 <= "00000000";
			when "01100100" => vec_0 <= "00000110";	--Letter "d"
									 vec_1 <= "00000110";
									 vec_2 <= "01111110";
									 vec_3 <= "11000110";
									 vec_4 <= "11000110";
									 vec_5 <= "11000110";
									 vec_6 <= "01111110";
									 vec_7 <= "00000000";						 
			when "01100101" => vec_0 <= "00000000";	--Letter "e"
									 vec_1 <= "01111100";
									 vec_2 <= "11000110";
									 vec_3 <= "11000110";
									 vec_4 <= "11111110";
									 vec_5 <= "11000000";
									 vec_6 <= "01111100";
									 vec_7 <= "00000000";
			when "01100110" => vec_0 <= "00011110";	--Letter "f"
									 vec_1 <= "00110000";
									 vec_2 <= "11111100";
									 vec_3 <= "00110000";
									 vec_4 <= "00110000";
									 vec_5 <= "00110000";
									 vec_6 <= "00110000";
									 vec_7 <= "00000000";
			when "01100111" => vec_0 <= "00000000";	--Letter "g"
									 vec_1 <= "01111110";
									 vec_2 <= "11000110";
									 vec_3 <= "11000110";
									 vec_4 <= "11000110";
									 vec_5 <= "01111110";
									 vec_6 <= "00000110";
									 vec_7 <= "01111100";
			when "01101000" => vec_0 <= "11000000";	--Letter "h"
									 vec_1 <= "11000000";
									 vec_2 <= "11111100";
									 vec_3 <= "11000110";
									 vec_4 <= "11000110";
									 vec_5 <= "11000110";
									 vec_6 <= "11000110";
									 vec_7 <= "00000000";							
			when "01101001" => vec_0 <= "00110000";	--Letter "i"
									 vec_1 <= "00000000";
									 vec_2 <= "00110000";
									 vec_3 <= "00110000";
									 vec_4 <= "00110000";
									 vec_5 <= "00110000";
									 vec_6 <= "00011000";
									 vec_7 <= "00000000";
			when "01101010" => vec_0 <= "00001100";	--Letter "j"
									 vec_1 <= "00000000";
									 vec_2 <= "00001100";
									 vec_3 <= "00001100";
									 vec_4 <= "00001100";
									 vec_5 <= "00001100";
									 vec_6 <= "11001100";
									 vec_7 <= "01111000";
			when "01101011" => vec_0 <= "11000000";	--Letter "k"
									 vec_1 <= "11000000";
									 vec_2 <= "11000110";
									 vec_3 <= "11001100";
									 vec_4 <= "11111000";
									 vec_5 <= "11001100";
									 vec_6 <= "11000110";
									 vec_7 <= "00000000";
			when "01101100" => vec_0 <= "00110000";	--Letter "l"
									 vec_1 <= "00110000";
									 vec_2 <= "00110000";
									 vec_3 <= "00110000";
									 vec_4 <= "00110000";
									 vec_5 <= "00110000";
									 vec_6 <= "00011000";
									 vec_7 <= "00000000";
			when "01101101" => vec_0 <= "00000000";	--Letter "m"
									 vec_1 <= "11101100";
									 vec_2 <= "11111110";
									 vec_3 <= "11010110";
									 vec_4 <= "11000110";
									 vec_5 <= "11000110";
									 vec_6 <= "11000110";
									 vec_7 <= "00000000";
			when "01101110" => vec_0 <= "00000000";	--Letter "n"
									 vec_1 <= "11111100";
									 vec_2 <= "11000110";
									 vec_3 <= "11000110";
									 vec_4 <= "11000110";
									 vec_5 <= "11000110";
									 vec_6 <= "11000110";
									 vec_7 <= "00000000";
			when "01101111" => vec_0 <= "00000000";	--Letter "o"
									 vec_1 <= "01111100";
									 vec_2 <= "11000110";
									 vec_3 <= "11000110";
									 vec_4 <= "11000110";
									 vec_5 <= "11000110";
									 vec_6 <= "01111100";
									 vec_7 <= "00000000";
			when "01110000" => vec_0 <= "00000000";	--Letter "p"
									 vec_1 <= "11111100";
									 vec_2 <= "11000110";
									 vec_3 <= "11000110";
									 vec_4 <= "11000110";
									 vec_5 <= "11111100";
									 vec_6 <= "11000000";
									 vec_7 <= "11000000";
			when "01110001" => vec_0 <= "00000000";	--Letter "q"
									 vec_1 <= "01111110";
									 vec_2 <= "11000110";
									 vec_3 <= "11000110";
									 vec_4 <= "11000110";
									 vec_5 <= "01111110";
									 vec_6 <= "00000110";
									 vec_7 <= "00000110";
			when "01110010" => vec_0 <= "00000000";	--Letter "r"
									 vec_1 <= "11111100";
									 vec_2 <= "11000110";
									 vec_3 <= "11000000";
									 vec_4 <= "11000000";
									 vec_5 <= "11000000";
									 vec_6 <= "11000000";
									 vec_7 <= "00000000";
			when "01110011" => vec_0 <= "00000000";	--Letter "s"
									 vec_1 <= "01111100";
									 vec_2 <= "11000000";
									 vec_3 <= "01111100";
									 vec_4 <= "00000110";
									 vec_5 <= "00000110";
									 vec_6 <= "11111100";
									 vec_7 <= "00000000";
			when "01110100" => vec_0 <= "00110000";	--Letter "t"
									 vec_1 <= "11111100";
									 vec_2 <= "00110000";
									 vec_3 <= "00110000";
									 vec_4 <= "00110000";
									 vec_5 <= "00110000";
									 vec_6 <= "00011110";
									 vec_7 <= "00000000";
			when "01110101" => vec_0 <= "00000000";	--Letter "u"
									 vec_1 <= "11000110";
									 vec_2 <= "11000110";
									 vec_3 <= "11000110";
									 vec_4 <= "11000110";
									 vec_5 <= "11000110";
									 vec_6 <= "01111110";
									 vec_7 <= "00000000";			 
			when "01110110" => vec_0 <= "00000000";	--Letter "v"
									 vec_1 <= "11000110";
									 vec_2 <= "11000110";
									 vec_3 <= "11000110";
									 vec_4 <= "11000110";
									 vec_5 <= "01101100";
									 vec_6 <= "00111000";
									 vec_7 <= "00000000";
			when "01110111" => vec_0 <= "00000000";	--Letter "w"
									 vec_1 <= "11000110";
									 vec_2 <= "11000110";
									 vec_3 <= "11000110";
									 vec_4 <= "11010110";
									 vec_5 <= "11111110";
									 vec_6 <= "01101100";
									 vec_7 <= "00000000";
			when "01111000" => vec_0 <= "00000000";	--Letter "x"
									 vec_1 <= "11000110";
									 vec_2 <= "01101100";
									 vec_3 <= "00111000";
									 vec_4 <= "01101100";
									 vec_5 <= "11000110";
									 vec_6 <= "11000110";
									 vec_7 <= "00000000";
			when "01111001" => vec_0 <= "00000000";	--Letter "y"
									 vec_1 <= "11000110";
									 vec_2 <= "11000110";
									 vec_3 <= "11000110";
									 vec_4 <= "11000110";
									 vec_5 <= "01111110";
									 vec_6 <= "00000110";
									 vec_7 <= "01111100";
			when "01111010" => vec_0 <= "00000000";	--Letter "z"
									 vec_1 <= "01111110";
									 vec_2 <= "00001100";
									 vec_3 <= "00011000";
									 vec_4 <= "00110000";
									 vec_5 <= "01100000";
									 vec_6 <= "11111110";
									 vec_7 <= "00000000";
			when "01111100" => vec_0 <= "00011000";	--Letter "|"
									 vec_1 <= "00011000";
									 vec_2 <= "00011000";
									 vec_3 <= "00011000";
									 vec_4 <= "00011000";
									 vec_5 <= "00011000";
									 vec_6 <= "00011000";
									 vec_7 <= "00011000";
			when others => 	 vec_0 <= "00000000";	--Blank
									 vec_1 <= "00000000";
									 vec_2 <= "00000000";
									 vec_3 <= "00000000";
									 vec_4 <= "00000000";
									 vec_5 <= "00000000";
									 vec_6 <= "00000000";
									 vec_7 <= "00000000";
			end case;
		end if;
	end process char_gen_proc;
end architecture basic;