--CLOCK AND PULSE GENERATOR-------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.numeric_std.all;
use ieee.std_logic_unsigned.all;

entity clk_gen is
   Port ( clk : in std_logic;
			 SCK : inout std_logic := '0';
			 UART_CLK : inout std_logic := '0'
   );
end clk_gen;

architecture basic of clk_gen is
begin
	--This generates the SPI_SCK
	clk_8_3MHZ_proc : process (clk) is
	constant Divider : integer := 6; --Divide by 6 to get 8.3 MHz MHz
	variable Counter : integer range 0 to Divider := 0;
	begin
	   if (clk'event and clk='1') then
			Counter := Counter + 1;
			if (Counter = (Divider/2)) then
				SCK <= not SCK;
				Counter := 0;
			end if;
		end if;
	end process clk_8_3MHZ_proc;
	
	--This generates the UART_CLK
	clk_UART_proc : process (clk) is
	constant Tpw_clk : integer := 50000000; --50 MHz onboard-oscillator
	constant baudrate : integer := 9600;
	constant divider : integer := Tpw_clk / baudrate;
	variable Counter : integer range 0 to divider := 0;
	begin
	   if (clk'event and clk='1') then
			Counter := Counter + 1;
			if (Counter = (Divider / 2)) then
				UART_CLK <= not UART_CLK ;
				Counter := 0;
			end if;
		end if;
	end process clk_UART_proc;
	
end architecture basic;