--GENERATE FLOAT FROM STD_LOGIC_VECTOR--------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.numeric_std.all;
use ieee.std_logic_unsigned.all;

entity float_gen is
   Port ( clk : in std_logic;
			 std_to_float 	: in std_logic_VECTOR(15 downto 0);
			 float_gen 		: out std_logic_VECTOR(31 downto 0) := "00000000000000000000000000000000"
   );
end float_gen;

architecture basic of float_gen is
begin
	float_gen_proc : process (clk)
	variable highbit : integer range 15 downto 0 := 0;
	begin
	   if (clk='1' and clk'event) then
			float_gen(31) <= '0';
			-- First we calculate the exponent field
			if(std_to_float(15)='1') then float_gen(30 downto 23) <= "10001110"; highbit := 15;
			elsif(std_to_float(14)='1') then float_gen(30 downto 23) <= "10001101"; highbit := 14;
			elsif(std_to_float(13)='1') then float_gen(30 downto 23) <= "10001100"; highbit := 13;
			elsif(std_to_float(12)='1') then float_gen(30 downto 23) <= "10001011"; highbit := 12;
			elsif(std_to_float(11)='1') then float_gen(30 downto 23) <= "10001010"; highbit := 11;
			elsif(std_to_float(10)='1') then float_gen(30 downto 23) <= "10001001";	highbit := 10;
			elsif(std_to_float(9)='1') then float_gen(30 downto 23) <= "10001000"; highbit := 9;
			elsif(std_to_float(8)='1') then float_gen(30 downto 23) <= "10000111"; highbit := 8;
			elsif(std_to_float(7)='1') then float_gen(30 downto 23) <= "10000110"; highbit := 7;
			elsif(std_to_float(6)='1') then float_gen(30 downto 23) <= "10000101"; highbit := 6;
			elsif(std_to_float(5)='1') then float_gen(30 downto 23) <= "10000100"; highbit := 5;
			elsif(std_to_float(4)='1') then float_gen(30 downto 23) <= "10000011"; highbit := 4;
			elsif(std_to_float(3)='1') then float_gen(30 downto 23) <= "10000010"; highbit := 3;
			elsif(std_to_float(2)='1') then float_gen(30 downto 23) <= "10000001"; highbit := 2;
			elsif(std_to_float(1)='1') then float_gen(30 downto 23) <= "10000000"; highbit := 1;
			elsif(std_to_float(0)='1') then float_gen(30 downto 23) <= "01111111"; highbit := 0;
			else float_gen(30 downto 23) <= "00000000"; highbit := 0;
			end if;
			
			-- Now we calculate the significand
			for i in 22 downto 7 loop
				if(highbit > 0) then
					float_gen(i) <= std_to_float(highbit - 1);
					highbit := highbit - 1;
				end if;
			end loop;
			
			-- Add the rest, which will always be zero
			float_gen(6 downto 0) <= "0000000";
		end if;
	end process float_gen_proc;
end architecture basic;