--LCD CONTROL--------------------------------------------------------------
--This is just used for simple debugging.
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.numeric_std.all;
use ieee.std_logic_unsigned.all;
--LCD-interface
entity lcd is
   Port ( clk : in std_logic;
			 reset : in std_logic;
			 SF_D_11,SF_D_10,SF_D_9,SF_D_8 : out std_logic := '0';
			 LCD_E,LCD_RS,LCD_RW : out std_logic := '0';
			 P_Value : in std_logic_vector(11 downto 0);
			 Out_Value : in std_logic_vector(11 downto 0)
   );
end lcd;

architecture basic of lcd is
type LCD_state_type is (init1, init2, init3, init4, init5, init6, init7, init8, init9, idle, 
							   char, send);
signal LCD_state : LCD_state_type := init1;
signal LCD_nextstate : LCD_state_type := init1;
begin
	lcd_proc : process (clk)
	variable counter : integer := 0;
	variable initcnt : integer := 0;
	variable initdly : integer;
	variable charcnt : integer := 0;
	variable send1 : std_logic_vector(3 downto 0) := "0000";
	variable send2 : std_logic_vector(3 downto 0) := "0000";
	variable LCD_OUT : std_logic_vector(3 downto 0) := "0000";
	variable test_vec : std_logic_vector(7 downto 0);
	begin
	   if (clk='0' and clk'event) then
			if(reset='1') then LCD_state <= init1; counter := 0; end if;
			case LCD_state is
				when init1 =>
					counter := counter+1;
					if(counter=750001) then
						counter:=0;
						LCD_state <= init2;
					end if;
				when init2 =>
					counter := counter+1;
					LCD_OUT:="0011";
					LCD_E <= '1';
					if(counter=13) then
						LCD_OUT:="0000";
						LCD_E <= '0';
						counter:=0;
						if(initcnt=2) then LCD_state <= init3; initcnt:=initcnt+1; initdly := 2001; end if;
						if(initcnt=1) then LCD_state <= init3; initcnt:=initcnt+1; initdly := 5001; end if;
						if(initcnt=0) then LCD_state <= init3; initcnt:=initcnt+1; initdly := 205001; end if;
					end if;
				when init3 =>
					counter := counter+1;
					if(counter=initdly) then
						counter:=0;
						LCD_state <= init2;
						if(initcnt = 3) then	LCD_state <= init4; end if;
					end if;
				when init4 =>
					counter := counter+1;
					if(counter=1) then
						LCD_OUT:="0010";
						LCD_E <= '1';
					end if;
					if(counter=13) then
						LCD_OUT:="0000";
						LCD_E <= '0';
					end if;
					if(counter=2013) then
						counter:=0;
						LCD_state <= init5;
					end if;
				when init5 =>		--Start display config, send 0x28
					send1 := "0010";
					send2 := "1000";
					LCD_state <= send;
					LCD_nextstate <= init6;
				when init6 =>		--Display config, send 0x06
					send1 := "0000";
					send2 := "0110";
					LCD_state <= send;
					LCD_nextstate <= init7;
				when init7 =>		--Display config, send 0x0C
					send1 := "0000";
					send2 := "1100";
					LCD_state <= send;
					LCD_nextstate <= init8;
				when init8 =>		--Display config, clear screen
					send1 := "0000";
					send2 := "0001";
					LCD_state <= send;
					LCD_nextstate <= init9;
				when init9 =>		--Display config, delay
					counter := counter +1;
					if(counter=82000) then
						LCD_state <= char;
						LCD_nextstate <= char;
						counter := 0;
					end if;
				when char =>				--Write characters
					case charcnt is
					when 0 =>				--Set startadress
						LCD_RS <= '0';
						send1 := "1000";
						send2 := "0000";
						LCD_nextstate <= char;
					when 1 | 18 =>			--P
						LCD_RS <= '1';
						send1 := "0101";	
						send2 := "0000";
					when 2 | 22 =>			--r
						send1 := "0111";	
						send2 := "0010";
					when 3 =>				--o
						send1 := "0110";	
						send2 := "1111";
					when 4 | 6 | 7 => 	--s	
						send1 := "0111";	
						send2 := "0011";
					when 5 =>				--e
						send1 := "0110";	
						send2 := "0101";	
					when 8 | 25 =>				--:
						send1 := "0011";	
						send2 := "1010";
					when 9 | 10 | 11 | 12 | 13 | 14 | 15 | 16 =>
						send1 := "0011";
						if(P_Value(20-charcnt) = '0') then send2 := "0000";
						else send2 := "0001";
						end if;
					when 17 =>				--Set next line
						LCD_RS <= '0';
						send1 := "1100";
						send2 := "0000";
					when 19 | 20 | 23 =>	--a
						send1 := "0110";	
						send2 := "0001";	
					when 21 =>				--d
						send1 := "0110";	
						send2 := "0100";	
					when 24 =>				--g
						send1 := "0110";	
						send2 := "0111";
					when 26 | 27 | 28 | 29 | 30 | 31 | 32 | 33 =>
						send1 := "0011";
						if(Out_Value(37-charcnt) = '0') then send2 := "0000";
						else send2 := "0001";
						end if;
						if(charcnt=33) then
							LCD_nextstate <= idle;
						end if;
					when others =>
						send1 := "0010";
						send2 := "0000";
					end case;
					charcnt := charcnt +1;
					counter := 0;
					LCD_state <= send;
				when send =>
					counter := counter +1;
					case counter is
					when 1 =>
						LCD_E <= '1';
						LCD_OUT:=send1;
					when 13 =>
						LCD_E <= '0';
						LCD_OUT:="0000";
					when 63 =>
						LCD_E <= '1';
						LCD_OUT:=send2;
					when 75 =>
						LCD_E <= '0';
						LCD_OUT:="0000";
					when 2075 =>
						counter := 0;
						LCD_state <= LCD_nextstate;
					when others =>
						initdly := initdly;
					end case;
				when idle => 
					LCD_RS <= '0';
					counter := counter +1;
					if(counter = 25000000) then
						charcnt := 0;
						counter := 0;
						LCD_state <= init8;
					end if;
			end case;
			SF_D_11 <= LCD_OUT(3);
			SF_D_10 <= LCD_OUT(2);
			SF_D_9 <= LCD_OUT(1);
			SF_D_8 <= LCD_OUT(0);
		end if;
	end process lcd_proc;
end architecture basic;