--Reference generator / rotary button debouncer-------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.numeric_std.all;
use ieee.std_logic_unsigned.all;
use work.global_package.all;

entity ref_gen is
   Port ( clk : in std_logic;
			 ROT_A : in std_logic;
			 ROT_B : in std_logic;
			 Ref : out std_logic_vector(7 downto 0) := "00000000"
   );
end ref_gen;

architecture basic of ref_gen is
signal rotary_q1 			: std_logic;
signal rotary_q2 			: std_logic;
signal delay_rotary_q1 	: std_logic;
begin
	rotary_filter: process(clk)
	variable rotary_in : std_logic_vector(1 downto 0);
	begin
	if clk'event and clk='1' then
		rotary_in := ROT_B & ROT_A;
		case rotary_in is
			when "00" => rotary_q1 <= '0';
				rotary_q2 <= rotary_q2;
			when "01" => rotary_q1 <= rotary_q1;
				rotary_q2 <= '0';
			when "10" => rotary_q1 <= rotary_q1;
				rotary_q2 <= '1';
			when "11" => rotary_q1 <= '1';
				rotary_q2 <= rotary_q2;
			when others => rotary_q1 <= rotary_q1;
				rotary_q2 <= rotary_q2;
		end case;
	end if;
	end process rotary_filter;
	
	direction: process(clk)
	variable int_ref : std_logic_vector(7 downto 0) := "00000000";
	begin
	if clk'event and clk='1' then
		delay_rotary_q1 <= rotary_q1;
		if rotary_q1='1' and delay_rotary_q1='0' then
			if (rotary_q2='0') then 	--turning right
				if(int_ref = "00000000") then int_ref := "00000000";
				else int_ref := int_ref - 5;
				end if;
			else 								--turning left
				if(int_ref = "11111111") then int_ref := "11111111";
				else int_ref := int_ref + 5;
				end if;
			end if;
			Ref <= int_ref;
		end if;
	end if;
	end process direction;
	
end architecture basic;