--PID STATEMACHINE CONTROLLER--------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.numeric_std.all;
use ieee.std_logic_unsigned.all;
use work.global_package.all;

entity PID_SM is
   Port ( clk : in std_logic;
			 PID_state : inout PID_state_type := run_SPI;
			 SPI_done, subtract_done, P_done, I_done, D_done, sum_done : in std_logic
   );
end PID_SM;

architecture basic of PID_SM is
begin
	PID_SM_proc : process (clk)
	begin
	   if (clk='0' and clk'event) then
			if(PID_state=run_SPI and SPI_done = '1') then
				PID_state <= calc_error;
			elsif(PID_state=calc_error and subtract_done = '1') then
				PID_state <= calc_PID;
			elsif(PID_state=calc_PID and P_done = '1' and I_done = '1' and D_done = '1') then
				PID_state <= calc_sum;
			elsif(PID_state=calc_sum and sum_done = '1') then
				PID_state <= run_SPI;
			end if;
		end if;
	end process PID_SM_proc;
end architecture basic;