--SUMMER--------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.numeric_std.all;
use ieee.std_logic_unsigned.all;
use work.global_package.all;

entity summer is
   Port ( clk : in std_logic;
			 Proportional : in integer;
			 Integrator : in integer range -4095 to 4095;
			 Derivator : in integer;
			 Out_Value : out std_logic_vector(11 downto 0) := "000000000000";
			 PID_state : in PID_state_type;
			 sum_done : inout std_logic
   );
end summer;

architecture basic of summer is
begin
	summer_proc : process (clk)
	variable sum : integer := 0;
	variable Out_value_Int : integer range 0 to 4095;
	begin
	   if (clk='0' and clk'event) then
			if(PID_state = calc_sum and sum_done <= '0') then
				sum := Proportional + integrator;
				if(sum > 4095) then
					sum := 4095;
				end if;
				if(sum < 0) then
					sum := 0;
				end if;
				Out_Value <= conv_std_logic_vector(sum, 12); --Outvalue is 0-4095, or 12 bits
				sum_done <= '1';
			end if;
			if(PID_state = run_SPI) then 
				sum_done <= '0';
			end if;
		end if;
	end process summer_proc;
end architecture basic;