--PROPORTIONAL GAIN--------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.numeric_std.all;
use ieee.std_logic_unsigned.all;
use work.global_package.all;

entity proportional is
   Port ( error 		: in integer;
			 clk 			: in std_logic;
			 PID_state 	: in PID_state_type;
			 prop_out 	: out integer := 0;
			 P_done 		: inout std_logic := '0';
			 Kp 			: in std_logic_vector(3 downto 0)
   );
end proportional;

architecture basic of proportional is
begin
	proportional_proc : process (clk, error) is
	begin
	   if (clk='0' and clk'event) then
			if(PID_state = calc_PID and P_done = '0') then
				prop_out <= error * conv_integer(Kp);
				P_done <= '1';
			elsif(PID_state = calc_sum) then P_done <= '0';
			end if;
		end if;
	end process proportional_proc;
end architecture basic;