--PID STATEMACHINE CONTROLLER--------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.numeric_std.all;
use ieee.std_logic_unsigned.all;
use work.global_package.all;

entity SYS_SM is
   Port ( clk : in std_logic;
		    reset : in std_logic;
			 SYS_state : inout SYS_state_type := idle;
			 SPI_done, PID_done : in std_logic
   );
end SYS_SM;

architecture basic of SYS_SM is
begin
	SYS_SM_proc : process (clk) is
	constant clk_speed : integer := 50000000;
	variable counter : integer range 0 to 50000000 := 0;
	begin
	   if (clk='0' and clk'event) then
			counter := counter + 1;
			if(counter = clk_speed/sample_time and SYS_state = idle) then
				SYS_state <= calc_PID;
				counter := 0;
			end if;
			if(reset='1') then SYS_state <= idle; end if;
			if(SYS_state=calc_PID and PID_done = '1') then
				SYS_state <= run_SPI;
			elsif(SYS_state=run_SPI and SPI_done = '1') then
				SYS_state <= idle;
			end if;
		end if;
	end process SYS_SM_proc;
end architecture basic;