--	Package File Template
--
--	Purpose: This package defines supplemental types, subtypes, 
--		 constants, and functions 

library ieee;
use ieee.std_logic_1164.all; -- for std_logic_vector

package global_package is
type SYS_state_type is (idle, run_SPI, calc_PID);
type UART_queue is array(0 to 5) of std_logic_vector(7 downto 0);
constant sample_time : integer := 256;						--How often to "refresh" system
constant sample_time_float : std_logic_vector(31 downto 0) := "01000011100000000000000000000000";

-- These are the MPC constants.
-- System matrix, these must be converted to 32 bit floats
--constant A11 : integer := -20;
--constant A12 : integer := -3;
--constant A21 : integer := 3;
--constant A22 : integer := -0.1;
--constant B1	 : integer := 10;
--constant B2  : integer := 0;
constant n_x : integer := 2;

type array1 is array(0 to n_x-1) of std_logic_vector(31 downto 0);
type array2 is array(0 to n_x-1) of array1;

constant A : array2 := (("11000001101000000000000000000000", "11000000010000000000000000000000"), 
							 ("01000000010000000000000000000000", "10111101110011001100110011001101")); 
constant B : array1 := ("01000001001000000000000000000000",
								"00000000000000000000000000000000");
								
end package global_package;