--INITIALIZATION--------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.numeric_std.all;
use ieee.std_logic_unsigned.all;

entity init is
   Port ( clk : in std_logic;
			 BTN_EAST : in std_logic;
			 RESET : inout std_logic := '0';
			 SPI_SS_B : out std_logic := '1';
			 SF_CE0 : out std_logic := '1';
			 FPGA_INIT_B : out std_logic := '1'
   );
end init;

architecture basic of init is
begin
	reset_proc : process (clk)
	variable debounce_cnt : integer := 0;
	begin
	   if (clk='1' and clk'event) then
			if(debounce_cnt > 0) then debounce_cnt:=debounce_cnt-1; end if;
			if(debounce_cnt = 99980) then RESET<='0'; end if;
			if((BTN_EAST='1') and (debounce_cnt=0)) then
				RESET <= '1';
				debounce_cnt := 100000; --Wait for 100000 cycles, or 2 ms before allowing new reset
			end if;
		end if;
	end process reset_proc;

	init_proc : process (clk)
	begin
	   if (clk='0' and clk'event) then
			if(RESET='1') then
				SPI_SS_B <= '1';
				SF_CE0 <= '1';
				FPGA_INIT_B <= '1';
			end if;
		end if;
	end process init_proc;
end architecture basic;