--GENERATE STD_LOGIC_VECTOR FROM FLOAT--------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.numeric_std.all;
use ieee.std_logic_unsigned.all;

entity std_gen is
   Port ( clk : in std_logic;
			 float_to_std 	: in std_logic_VECTOR(31 downto 0);
			 std_gen 		: out std_logic_VECTOR(15 downto 0) := "0000000000000000"
   );
end std_gen;

architecture basic of std_gen is
begin
	std_gen_proc : process (clk)
	variable pos : integer range 15 downto 0 := 0;
	begin
	   if (clk='1' and clk'event) then
			std_gen <= "0000000000000000";
			-- First we calculate where to "begin"
			if(float_to_std(30 downto 23) = "01111111") then pos := 0;
			elsif(float_to_std(30 downto 23) = "10000000") then pos := 1;
			elsif(float_to_std(30 downto 23) = "10000001") then pos := 2;
			elsif(float_to_std(30 downto 23) = "10000010") then pos := 3;
			elsif(float_to_std(30 downto 23) = "10000011") then pos := 4;
			elsif(float_to_std(30 downto 23) = "10000100") then pos := 5;
			elsif(float_to_std(30 downto 23) = "10000101") then pos := 6;
			elsif(float_to_std(30 downto 23) = "10000110") then pos := 7;
			elsif(float_to_std(30 downto 23) = "10000111") then pos := 8;
			elsif(float_to_std(30 downto 23) = "10001000") then pos := 9;
			elsif(float_to_std(30 downto 23) = "10001001") then pos := 10;
			elsif(float_to_std(30 downto 23) = "10001010") then pos := 11;
			elsif(float_to_std(30 downto 23) = "10001011") then pos := 12;
			elsif(float_to_std(30 downto 23) = "10001100") then pos := 13;
			elsif(float_to_std(30 downto 23) = "10001101") then pos := 14;
			elsif(float_to_std(30 downto 23) = "10001110") then pos := 15;
			end if;
			std_gen(pos) <= '1';
					
			-- Now we place the rest after this '1'
			for i in 22 downto 7 loop
				if(pos > 0) then
					pos := pos - 1;
					if(float_to_std(i) = '1') then std_gen(pos) <= '1'; end if;
				end if;
			end loop;

		end if;
	end process std_gen_proc;
end architecture basic;